--- nagios-cvs/xdata/xodtemplate.c.orig	Wed Mar 24 11:45:45 2004
+++ nagios-cvs/xdata/xodtemplate.c	Wed Mar 24 12:12:18 2004
@@ -3,7 +3,7 @@
  * XODTEMPLATE.C - Template-based object configuration data input routines
  *
  * Copyright (c) 2001-2004 Ethan Galstad (nagios@nagios.org)
- * Last Modified: 03-23-2004
+ * Last Modified: 03-24-2004
  *
  * Description:
  *
@@ -9333,21 +9333,39 @@
 		
 		/* use standard matching... */
 		else{
+			/* return a list of all hostgroups */
+			if(!strcmp(temp_ptr,"*")){
+
+				found_match=TRUE;
 
-			/* this hostgroup should be excluded (rejected) */
-			if(temp_ptr[0]=='!'){
-				reject_item=TRUE;
-				temp_ptr++;
+				for(temp_hostgroup=xodtemplate_hostgroup_list;temp_hostgroup!=NULL;temp_hostgroup=temp_hostgroup->next){	
+
+					if(temp_hostgroup->hostgroup_name==NULL)
+						continue;
+
+					/* add hostgroup to list */
+					xodtemplate_add_hostgroup_members_to_hostlist(list,temp_hostgroup);
+				        }
 			        }
 
-			/* find the hostgroup */
-			temp_hostgroup=xodtemplate_find_real_hostgroup(temp_ptr);
-			if(temp_hostgroup!=NULL){
+			/* else this is just a single hostgroup... */
+			else{
+			
+				/* this hostgroup should be excluded (rejected) */
+				if(temp_ptr[0]=='!'){
+					reject_item=TRUE;
+					temp_ptr++;
+			        	}
 
-				found_match=TRUE;
+				/* find the hostgroup */
+				temp_hostgroup=xodtemplate_find_real_hostgroup(temp_ptr);
+				if(temp_hostgroup!=NULL){
+
+					found_match=TRUE;
 
-				/* add hostgroup members to proper list */
-				xodtemplate_add_hostgroup_members_to_hostlist((reject_item==TRUE)?reject_list:list,temp_hostgroup);
+					/* add hostgroup members to proper list */
+					xodtemplate_add_hostgroup_members_to_hostlist((reject_item==TRUE)?reject_list:list,temp_hostgroup);
+				        }
 			        }
 		        }
 
